smart-proxy detects "master" as valid environment
Description

If [master] section of puppet.conf contains a modulepath, smart-proxy detects "master" as an environment, causing Foreman to

attempt to delete the "production" environment and import "master" instead.

Associated revisions

Revision 1c60be63 - 06/14/2013 07:33 AM - Greg Sutcliffe 

Fixes #2654 - Rewrite master as production when only one environment is found

Revision 5e4e4adf - 06/20/2013 04:52 AM - Greg Sutcliffe 

Fixes #2654 - Rewrite master as production when only one environment is found

(cherry picked from commit 1c60be634d26163cc7fe43f5adad1f9f75c3309d)

History

#1 - 06/11/2013 12:41 PM - Dominic Cleal

- Category set to Puppet

Which version of the proxy do you have installed?

#2 - 06/11/2013 12:44 PM - Jared Nelson

I'm using the Debian nightly builds. Currently 9999+debian1~nightlybuild1370929161

#3 - 06/11/2013 12:48 PM - Dominic Cleal

- Priority changed from Normal to High

- Target version set to 1.2.0

Ok, thanks.

#4 - 06/12/2013 06:27 AM - Greg Sutcliffe

- Status changed from New to Assigned

- Assignee set to Greg Sutcliffe

#5 - 06/12/2013 07:24 AM - Greg Sutcliffe

I can replicate this if there's no production environment specified - obviously if you have a modulepath for both [master] and [production] it just adds

master to the environment list. I assume we want to make some kind of hardcoded mapping that if there is only master, it should be named

production?

#6 - 06/12/2013 10:36 AM - Greg Sutcliffe

- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/smart-proxy/pull/94
#7 - 06/12/2013 11:20 AM - Jared Nelson

Puppet documentation says that [main], [master], [agent], and [user] are forbidden environment names. Wouldn't it make sense for smart-proxy to

simply ignore modulepaths within these blocks, as they don't/can't specify environments?

#8 - 06/13/2013 12:49 PM - Greg Sutcliffe

They're not valid for static definitions, that's true, but it's perfectly allowable to have:

[master]

modulepath = /path/to/my/stuff/$environment

and then in your filesystem

/path/to/my/stuff/master

/path/to/my/stuff/production

/path/to/my/stuff/development

This is especially true when using git, where 'master' is the default branch. Worse, Puppet will assume that a static path in [master] is actually an

environment called 'production' so we can't just ignore it.

I've added a specific remapping for master->production under certain logic which should fix the issue at hand - if not we can come back and make the

logic more complex (again, sigh :P)

#9 - 06/14/2013 08:18 AM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 1c60be634d26163cc7fe43f5adad1f9f75c3309d.

#10 - 07/10/2018 02:46 PM - Greg Sutcliffe

- Target version deleted (1.2.0)
